
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>SQL注入攻击:防御和检查SQL注入的手段 / iVAN</title>

    <meta name="description" content="SQL注入攻击:防御和检查SQL注入的手段 虽然前面有许多文章讨论了SQL注入,但今天所讨论的内容也许可帮助你检查自己的服务器,并采取相应防范措施.知彼知己,方可取胜.首先要清楚SQL注入攻击有哪些种类. 观察近来的一些安全事件及其后果,安全专家们已经得到一个结论,这些威胁主要是通过SQL注入造成的.虽然前面有许多文章讨论了SQL注入,但今天所讨论的内容也许可帮助你检查自己的服务器,并采取相应防范措施. SQL注入攻击的种类 知彼知己,方可取胜.首先要清楚SQL注入攻击有哪些种类. 1.没有正确过滤转义字符 在用户的输入没有为转义字符过滤">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">SQL注入攻击:防御和检查SQL注入的手段</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>虽然前面有许多文章讨论了SQL注入，但今天所讨论的内容也许可帮助你检查自己的服务器，并采取相应防范措施。知彼知己，方可取胜。首先要清楚SQL注入攻击有哪些种类。<br />
<br />观察近来的一些安全事件及其后果，安全专家们已经得到一个结论，这些威胁主要是通过SQL注入造成的。虽然前面有许多文章讨论了SQL注入，但今天所讨论的内容也许可帮助你检查自己的服务器，并采取相应防范措施。</p>
<p><strong>SQL注入攻击的种类</strong></p>
<p>知彼知己，方可取胜。首先要清楚SQL注入攻击有哪些种类。</p>
<p><strong>1.没有正确过滤转义字符</strong></p>
<p>在用户的输入没有为转义字符过滤时，就会发生这种形式的注入式攻击，它会被传递给一个SQL语句。这样就会导致应用程序的终端用户对数据库上的语句实施操纵。比方说，下面的这行代码就会演示这种漏洞：</p>
<p>statement := "SELECT * FROM users WHERE name = '" + userName + "';"</p>
<p>这种代码的设计目的是将一个特定的用户从其用户表中取出，但是，如果用户名被一个恶意的用户用一种特定的方式伪造，这个语句所执行的操作可能就不仅仅是代码的作者所期望的那样了。例如，将用户名变量(即username)设置为：</p>
<p>a' or 't'='t，此时原始语句发生了变化：</p>
<p>SELECT * FROM users WHERE name = 'a' OR 't'='t';</p>
<p>如果这种代码被用于一个认证过程，那么这个例子就能够强迫选择一个合法的用户名，因为赋值't'='t永远是正确的。</p>
<p>在一些SQL服务器上，如在SQL　Server中，任何一个SQL命令都可以通过这种方法被注入，包括执行多个语句。下面语句中的username的值将会导致删除“users”表，又可以从“data”表中选择所有的数据(实际上就是透露了每一个用户的信息)。</p>
<p>a';DROP TABLE users; SELECT * FROM data WHERE name LIKE '%</p>
<p>这就将最终的SQL语句变成下面这个样子：</p>
<p>SELECT * FROM users WHERE name = 'a';DROP TABLE users; SELECT *</p>
<p>FROM DATA WHERE name LIKE '%';</p>
<p>其它的SQL执行不会将执行同样查询中的多个命令作为一项安全措施。这会防止攻击者注入完全独立的查询，不过却不会阻止攻击者修改查询。</p>
<p><strong>2.Incorrect type handling</strong></p>
<p>如果一个用户提供的字段并非一个强类型，或者没有实施类型强制，就会发生这种形式的攻击。当在一个SQL语句中使用一个数字字段时，如果程序员没有检查用户输入的合法性(是否为数字型)就会发生这种攻击。例如：</p>
<p>statement := "SELECT * FROM data WHERE id = " + a_variable + ";"</p>
<p>从这个语句可以看出，作者希望a_variable是一个与“id”字段有关的数字。不过，如果终端用户选择一个字符串，就绕过了对转义字符的需要。例如，将a_variable设置为:1;DROP TABLE users，它会将“users”表从数据库中删除，SQL语句变成：SELECT * FROM DATA WHERE id = 1;DROP TABLE users;</p>
<p><strong>3.数据库服务器中的漏洞</strong></p>
<p>有时，数据库服务器软件中也存在着漏洞，如MYSQL服务器中mysql_real_escape_string()函数漏洞。这种漏洞允许一个攻击者根据错误的统一字符编码执行一次成功的SQL注入式攻击。</p>
<p><strong>4.盲目SQL注入式攻击</strong></p>
<p>当一个Web应用程序易于遭受攻击而其结果对攻击者却不见时，就会发生所谓的盲目SQL注入式攻击。有漏洞的网页可能并不会显示数据，而是根据注入到合法语句中的逻辑语句的结果显示不同的内容。这种攻击相当耗时，因为必须为每一个获得的字节而精心构造一个新的语句。但是一旦漏洞的位置和目标信息的位置被确立以后，一种称为Absinthe的工具就可以使这种攻击自动化。</p>
<p><strong>5.条件响应</strong></p>
<p>注意，有一种SQL注入迫使数据库在一个普通的应用程序屏幕上计算一个逻辑语句的值：</p>
<p>SELECT booktitle FROM booklist WHERE bookId = 'OOk14cd' AND 1=1</p>
<p>这会导致一个标准的面面，而语句</p>
<p>SELECT booktitle FROM booklist WHERE bookId = 'OOk14cd' AND 1=2在页面易于受到SQL注入式攻击时，它有可能给出一个不同的结果。如此这般的一次注入将会证明盲目的SQL注入是可能的，它会使攻击者根据另外一个表中的某字段内容设计可以评判真伪的语句。</p>
<p><strong>6.条件性差错</strong></p>
<p>如果WHERE语句为真，这种类型的盲目SQL注入会迫使数据库评判一个引起错误的语句，从而导致一个SQL错误。例如：</p>
<p>SELECT 1/0 FROM users WHERE username='Ralph'。显然，如果用户Ralph存在的话，被零除将导致错误。</p>
<p><strong>7.时间延误</strong></p>
<p>时间延误是一种盲目的SQL注入，根据所注入的逻辑，它可以导致SQL引擎执行一个长队列或者是一个时间延误语句。攻击者可以衡量页面加载的时间，从而决定所注入的语句是否为真。</p>
<p>以上仅是对SQL攻击的粗略分类。但从技术上讲，如今的SQL注入攻击者们在如何找出有漏洞的网站方面更加聪明，也更加全面了。出现了一些新型的SQL攻击手段。黑客们可以使用各种工具来加速漏洞的利用过程。我们不妨看看the Asprox Trojan这种木马，它主要通过一个发布邮件的僵尸网络来传播，其整个工作过程可以这样描述：首先，通过受到控制的主机发送的垃圾邮件将此木马安装到电脑上，然后，受到此木马感染的电脑会下载一段二进制代码，在其启动时，它会使用搜索引擎搜索用微软的ASP技术建立表单的、有漏洞的网站。搜索的结果就成为SQL注入攻击的靶子清单。接着，这个木马会向这些站点发动SQL注入式攻击，使有些网站受到控制、破坏。访问这些受到控制和破坏的网站的用户将会受到欺骗，从另外一个站点下载一段恶意的JavaScript代码。最后，这段代码将用户指引到第三个站点，这里有更多的恶意软件，如窃取口令的木马。</p>
<p>以前，我们经常警告或建议Web应用程序的程序员们对其代码进行测试并打补丁，虽然SQL注入漏洞被发现和利用的机率并不太高。但近来攻击者们越来越多地发现并恶意地利用这些漏洞。因此，在部署其软件之前，开发人员应当更加主动地测试其代码，并在新的漏洞出现后立即对代码打补丁。</p>
<p><strong>防御和检查SQL注入的手段</strong></p>
<p><strong>1.使用参数化的过滤性语句</strong></p>
<p>要防御SQL注入，用户的输入就绝对不能直接被嵌入到SQL语句中。恰恰相反，用户的输入必须进行过滤，或者使用参数化的语句。参数化的语句使用参数而不是将用户输入嵌入到语句中。在多数情况中，SQL语句就得以修正。然后，用户输入就被限于一个参数。下面是一个使用Java和JDBC API例子：</p>
<p>PreparedStatement prep = conn.prepareStatement("SELECT * FROM USERS WHERE</p>
<p>PASSWORD=?");</p>
<p>prep.setString(1, pwd);</p>
<p>总体上讲，有两种方法可以保证应用程序不易受到SQL注入的攻击，一是使用代码复查，二是强迫使用参数化语句的。强迫使用参数化的语句意味着嵌入用户输入的SQL语句在运行时将被拒绝。不过，目前支持这种特性的并不多。如H2 数据库引擎就支持。</p>
<p><strong>2.还要避免使用解释程序，因为这正是黑客们借以执行非法命令的手段。</strong></p>
<p><strong>3.防范SQL注入，还要避免出现一些详细的错误消息，因为黑客们可以利用这些消息。要使用一种标准的输入确认机制来验证所有的输入数据的长度、类型、语句、企业规则等。</strong></p>
<p><strong>4.使用专业的漏洞扫描工具。但防御SQL注入攻击也是不够的。</strong>攻击者们目前正在自动搜索攻击目标并实施攻击。其技术甚至可以轻易地被应用于其它的Web架构中的漏洞。企业应当投资于一些专业的漏洞扫描工具，如大名鼎鼎的Acunetix的Web漏洞扫描程序等。一个完善的漏洞扫描程序不同于网络扫描程序，它专门查找网站上的SQL注入式漏洞。最新的漏洞扫描程序可以查找最新发现的漏洞。</p>
<p><strong>5.最后一点，企业要在Web应用程序开发过程的所有阶段实施代码的安全检查。</strong>首先，要在部署Web应用之前实施安全测试，这种措施的意义比以前更大、更深远。企业还应当在部署之后用漏洞扫描工具和站点监视工具对网站进行测试。</p>
<p>Web安全拉警报已经响起，安全形式异常严峻，企业绝对不应当草率从事。安全重于泰山!</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-06 00:45:32</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e6%94%bb%e5%87%bb/" title="攻击">攻击</a>, <a href="https://www.iamivan.net/tag/%e8%af%ad%e5%8f%a5/" title="语句">语句</a>, <a href="https://www.iamivan.net/tag/%e6%bc%8f%e6%b4%9e/" title="漏洞">漏洞</a>, <a href="https://www.iamivan.net/tag/%e6%b3%a8%e5%85%a5%e5%bc%8f/" title="注入式">注入式</a>, <a href="https://www.iamivan.net/tag/sql%e6%b3%a8%e5%85%a5/" title="sql注入">sql注入</a>, <a href="https://www.iamivan.net/tag/%e6%b3%a8%e5%85%a5%e5%bc%8f%e6%94%bb%e5%87%bb/" title="注入式攻击">注入式攻击</a>, <a href="https://www.iamivan.net/tag/%e6%b3%a8%e5%85%a5%e6%bc%8f%e6%b4%9e/" title="注入漏洞">注入漏洞</a>, <a href="https://www.iamivan.net/tag/sql%e6%b3%a8%e5%85%a5%e7%9b%b2%e6%b3%a8/" title="sql注入盲注">sql注入盲注</a>, <a href="https://www.iamivan.net/tag/sql%e6%b3%a8%e5%85%a5%e6%94%bb%e5%87%bb/" title="sql注入攻击">sql注入攻击</a>, <a href="https://www.iamivan.net/tag/%e8%a2%ab%e6%b3%a8%e5%85%a5/" title="被注入">被注入</a>, <a href="https://www.iamivan.net/tag/sql%e6%b3%a8%e5%85%a5%e5%bc%8f/" title="SQL注入式">SQL注入式</a>, <a href="https://www.iamivan.net/tag/%e6%b3%a8%e5%85%a5%e5%ae%89%e5%85%a8%e6%bc%8f%e6%b4%9e/" title="注入安全漏洞">注入安全漏洞</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>SQL注入攻击:防御和检查SQL注入的手段的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd64Ymb.html" rel="bookmark">注入攻击-SQL注入和代码注入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				注入攻击 OWASP将注入攻击和跨站脚本攻击(XSS)列入网络应用程序十大常见安全风险.实际上,它们会一起出现,因为 XSS 攻击依赖于注入攻击的成功.虽然这是最明显的组合关系,但是注入攻击带来的不仅仅是 XSS. 注入攻击代指一类攻击,它们通过注入数据到一个网络应用程序以期获得执行,亦或是通过非预期的一个方式来执行恶意数据.这种类别的攻击包括跨站脚本攻击(XSS).SQL 注入攻击.头部注入攻击.日志注入攻击和全路径暴露.当然限于篇幅,这里只是一个简单的介绍. 这类攻击是每个程序员的梦魇.它们			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xp83QNM.html" rel="bookmark">ASP&period;NET如何防范SQL注入攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|sql|sql注入|注入|攻击 一.什么是SQL注入式攻击? 所谓SQL注入式攻击,就是攻击者把SQL命令插入到Web表单的输入域或页面请求的查询字符串,欺骗服务器执行恶意的SQL命令.在某些表单中,用户输入的内容直接用来构造(或者影响)动态SQL命令,或作为存储过程的输入参数,这类表单特别容易受到SQL注入式攻击.常见的SQL注入式攻击过程类如: ⑴ 某个ASP.NET Web应用有一个登录页面,这个登录页面控制着用户是否有权访问应用,它要求用户输入一个名称和密码. Webjx			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYA86b.html" rel="bookmark">PHP SQL 注入攻击预防办法与注入分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. php教程 配置文件 php.ini 中的 magic_quotes_gpc 选项没有打开,被置为 off 2. 开发者没有对数据类型进行检查和转义 不过事实上,第二点最为重要.我认为, 对用户输入的数据类型进行检查,向 mysql教程 提交正确的数据类型,这应该是一个 web 程序员最最基本的素质.但现实中,常常有许多小白式的 web 开发者忘了这点, 从而导致后门大开. 为什么说第二点最为重要?因为如果没有第二点的保证,magic_quotes_gpc 选项,不论为 on,还是为 of			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj853dp.html" rel="bookmark">常用的SQL注入攻击方法总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 没有正确过滤转义字符 在用户的输入没有转义字符过滤时,就会发生这种形式的注入或攻击,它会被传递给一个SQL语句.这样就会导致应用程序的终端用户对数据库上的语句实施操作.比方说,下面的这行代码就会演示这种漏洞:  代码如下 复制代码 &quot;SELECT * FROM users WHERE name = ' &quot; + userName + &quot; ' ;&quot; 这种代码的设计目的是将一个特定的用户从其用户表中取出,但是,如果用户名被一个恶意的用户用一种特定的方式伪造,这个语句			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baKjOnp.html" rel="bookmark">php mysql&lowbar;real&lowbar;escape&lowbar;string addslashes及mysql绑定参数防SQL注入攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				php mysql_real_escape_string addslashes及mysql绑定参数防SQL注入攻击 php防止SQL注入攻击一般有三种方法: 使用mysql_real_escape_string函数 使用addslashes函数 使用mysql bind_param() 本文章向大家详细介绍这三个方法在防止SQL注入攻击中的效果及区别. mysql_real_escape_string防sql注入攻击 mysql_real_escape_string() 函数转义 SQL 语句中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrXOD4z.html" rel="bookmark">php安全编程&mdash;sql注入攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:php安全编程-sql注入攻击 php安全编程--sql注入攻击 定义 SQL注入攻击指的是通过构建特殊的输入作为参数传入Web应用程序,而这些输入大都是SQL语法里的一些组合,通过执行SQL语句进而执行攻击者所要的操作,其主要原因是程序没有细致地过滤用户输入的数据,致使非法数据侵入系统. 根据相关技术原理,SQL注入可以分为平台层注入和代码层注入.前者由不安全的数据库配置或数据库平台的漏洞所致:后者主要是由于程序员对输入未进行细致地过滤,从而执行了非法的数据查询.基于此,SQL注入的产生			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xpny4KM.html" rel="bookmark">在ASP&period;NET中如何防范SQL注入式攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|sql|攻击 一.什么是SQL注入式攻击? 所谓SQL注入式攻击,就是攻击者把SQL命令插入到Web表单的输入域或页面请求的查询字符串,欺骗服务器执行恶意的SQL命令.在某些表单中,用户输入的内容直接用来构造(或者影响)动态SQL命令,或作为存储过程的输入参数,这类表单特别容易受到SQL注入式攻击.常见的SQL注入式攻击过程类如: ⑴ 某个ASP.NET Web应用有一个登录页面,这个登录页面控制着用户是否有权访问应用,它要求用户输入一个名称和密码. ⑵ 登录页面中输入的内容将直			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMqkwGz.html" rel="bookmark">ASP&period;NET中如何防范SQL注入式攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|攻击 一.什么是SQL注入式攻击?所谓SQL注入式攻击,就是攻击者把SQL命令插入到Web表单的输入域或页面请求的查询字符串,欺骗服务器执行恶意的SQL命令.在某些表单中,用户输入的内容直接用来构造(或者影响)动态SQL命令,或作为存储过程的输入参数,这类表单特别容易受到SQL注入式攻击.常见的SQL注入式攻击过程类如: ⑴ 某个ASP.NET Web应用有一个登录页面,这个登录页面控制着用户是否有权访问应用,它要求用户输入一个名称和密码. ⑵ 登录页面中输入的内容将直接用来构造			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5jJaz.html" rel="bookmark">讲解ASP&period;NET中如何防范SQL注入式攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|攻击 一.什么是SQL注入式攻击 所谓SQL注入式攻击,就是攻击者把SQL命令插入到Web表单的输入域或页面请求的查询字符串,欺骗服务器执行恶意的SQL命令.在某些表单中,用户输入的内容直接用来构造(或者影响)动态SQL命令,或作为存储过程的输入参数,这类表单特别容易受到SQL注入式攻击.常见的SQL注入式攻击过程类如: ⑴ 某个ASP.NET Web应用有一个登录页面,这个登录页面控制着用户是否有权访问应用,它要求用户输入一个名称和密码. ⑵ 登录页面中输入的内容将直接用来构造			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxvRjz.html" rel="bookmark" class="title">XML Web Service 安全性</a>
					<div>
						web|xml|安全|安全性     当我们谈及 XML Web Service 时,人们最关心的问题就是其安全性. XML Web Service 安全吗? 鉴于安全性涉及诸多方面(例如身份验证和授 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGoOOz.html" rel="bookmark" class="title">NetFilter&sol;iptables防火墙设置（上）</a>
					<div>
						大多数主要的Linux发行商,包括SuSE,在防火墙设置方面都有某些独特的用户接口特征.他们这样并没有错,但是这样我就无法直接得到最想要的配置,所以只好自己手动设置.Iptable man页面完全是个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPeZAz.html" rel="bookmark" class="title">四步提高网站PV</a>
					<div>
						又是好今天没写文章了,今天给大家介绍下如何增加网站的PV. 我们重视PV有这几个原因: 1.PV是衡量一个网站价值的重要参数,在相同的IP下,PV越高也就证明网站价值越大. 2.另外一个方面来说,网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPQy8z.html" rel="bookmark" class="title">PHP实例：email address 生成图片程序</a>
					<div>
						把下面的文件保存为index.php &lt;?/*MailX Managment System 0.8 Beta*/header(&quot;Content-type:image/png&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7n42b.html" rel="bookmark" class="title">win8怎么用键盘代替鼠标</a>
					<div>
						  win8怎么用键盘代替鼠标            1.在win8桌面上,打开控制面板,选择轻松使用,如图所示: 2.接着在轻松使用菜单面板上,点击&quot;更改键盘的工作方式&quot;按钮,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk26G5M.html" rel="bookmark" class="title">sphinx无法启动的解决</a>
					<div>
						  sphinx无法启动的解决 索引或者查询时提示:ERROR: invalid token in 配置文件 line 1 col 1.: 该提示表示当前的配置文件的编码不是UTF-8(无BOM头)格 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AaAnp.html" rel="bookmark" class="title">Word2013中怎样录制宏</a>
					<div>
						Word 2013中录制宏步骤1: 启动Word 2013并打开文档,在文档中输入需要进行处理的文字,然后在&quot;视图&quot;选项卡的&quot;宏&quot;组中单击&quot;宏&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdKX5M.html" rel="bookmark" class="title">Win8&sol;win8&period;1的IE10&sol;IE11无法显示Flash怎么办？</a>
					<div>
						  IE11 Flash问题是不少Win8.Win8.1的朋友常遇到的麻烦事.我们得知道--从Win8开始,微软默认为IE浏览器集成Adobe Flash Player插件.你看问题就来额,最近不少w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwx5Kp.html" rel="bookmark" class="title">ActiveMQ：Communications link failure问题以及解决办法</a>
					<div>
						ActiveMQ版本:5.5.1 MQ 所使用的 MySQL 是 InnoDB存储引擎 记录人:@郑昀 现象: 业务表面现象:无.系统现象:无. 日志信息:业务系统发送 MQ 消息时,下面这种错误日志 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVw3ekb.html" rel="bookmark" class="title">网页-如何建立个性化的mfc 浏览器</a>
					<div>
						问题描述 如何建立个性化的mfc 浏览器 我想问一下 ,我想要在mfc中开发一个网页,但是呢mfc自带的不好看,我就想自己设计一个网页来显示,这个应该怎么做呢?有没有人会呢?求助啊... 解决方案 w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYvNOM.html" rel="bookmark" class="title">如何进行网站的本地测试</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 时下做网站的,大部分朋友都用asp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8EBqp.html" rel="bookmark" class="title">智能家庭本周锋闻：苹果 HomeKit 犹抱琵琶半遮面</a>
					<div>
						  WWDC 2014主题演讲中,苹果花了不到120秒的时间来介绍 HomeKit,一套让 iPhone 来控制第三方智能家居设备.家电设备的 API 和开发工具包.具体怎么个控制法?仍要期待苹果公布 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1l2rjb.html" rel="bookmark" class="title">c语言-关于oj里面输入和输出的问题</a>
					<div>
						问题描述 关于oj里面输入和输出的问题 一个很简单的题目: 给定区间[-231, 231]内的3个整数A.B和C,请判断A+B是否大于C. 输入格式: 输入第1行给出正整数T(&lt;=10),是测试 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Ngo6z.html" rel="bookmark" class="title">5&period;22成都workshop：游戏日志处理探索-无服务器（Serverless）编程首秀</a>
					<div>
						实验背景介绍及环境准备 一. 实验背景: 游戏行业十分激烈,手机游戏的生命周期仅仅有6-12个月.如何通过云计算的弹性扩展等优势为游戏行业降低架构技术风险,集中精力主要业务的推广.投放以延长游戏生命周 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6ynPM.html" rel="bookmark" class="title">java笔记八：IO流之字符流与字符缓冲流</a>
					<div>
						java中字符流主要都是继承于Reader和Writer两个抽象类.用于对字符文本的读写操作.   一.转换类流 1 package com.iotest; 2 3 import java.io.Fi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxoydb.html" rel="bookmark" class="title">Ruff：物联网时代的Android触发产业革命</a>
					<div>
						物联网(IoT,Internet of Things)的全新时代就要来临. 过去几年内,智能硬件热潮席卷全球.然而和手机时代与PC时代相似,硬件的热潮无法带来行业的爆发性发展.在行业集体的尝试与失败之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3Y5dz.html" rel="bookmark" class="title">【C&sol;C&plus;&plus;学院】（23）Mysql数据库编程--C语言编程实现mysql客户端</a>
					<div>
						[送给在路上的程序员] 对于一个开发者而言,能够胜任系统中任意一个模块的开发是其核心价值的体现. 对于一个架构师而言,掌握各种语言的优势并可以利运用到系统中,由此简化系统的开发,是其架构生涯的第一步. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3Ro4z.html" rel="bookmark" class="title">link环境下制作一款《订餐软件》，listview如何实现点餐列表？</a>
					<div>
						问题描述 link环境下制作一款&lt;订餐软件&gt;,listview如何实现点餐列表? link环境下制作一款&lt;订餐软件&gt;,listview如何实现点餐列表? 解决方案 有很多的方式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX7l4z.html" rel="bookmark" class="title">&lbrack;cocos2dx&rsqb;精灵遮罩</a>
					<div>
						首先得理解一些东西. 1.理解颜色混合.精灵有个成员函数:setBlendFunc(),这个函数以一个ccBlendFunc类型的变量为参数.这个ccBlendFunc是个结构体.这个结构体中有两个变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB3Brb.html" rel="bookmark" class="title">MySQL高可用性之MySQL&plus;DRBD&plus;Heartbeat</a>
					<div>
						一.环境介绍 1.DRDB存储软件 DRBD是一个软件来实现数据实时.同步.异步的数据镜像块存储复制解决方案,主要功能是通过Linux内核实现. DRBD类似网络RAID-1功能写入本地的文件会通过网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYX99rb.html" rel="bookmark" class="title">8&period;6亿个人信息被&amp;quot&semi;偷&amp;quot&semi; 网络安全团队曝光交易内幕</a>
					<div>
						互联网到底会泄露多少信息?告诉你一个难以想象的数据,雨袭团信息安全团队轻松搜索出高达8.6亿条个人信息数据. 2010年,雨袭团由南京人姚威发起,从事网络安全工作.他们宣称&quot;不碰黑的东西&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRdxWp.html" rel="bookmark" class="title">《React Native移动开发实战》一一2&period;3  React Native的JSX解决方案</a>
					<div>
						2.3 React Native的JSX解决方案 JSX并不是一门新的开发语言,而是Facebook提出的语法方案:一种可以在JavaScript代码中直接书写HTML标签的语法糖,所以,JSX本质上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JxG0z.html" rel="bookmark" class="title">我国拟立法加强网络用户身份管理</a>
					<div>
						网民正通过电商网站买东西,现在我国将立法加强网民个人信息管理 新华社 图 24日上午十一届全国人大常委会第三十次会议审议了委员长会议提请审议的&lt;全国人民代表大会常务委员会关于加强网络信息保护的决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBP8PM.html" rel="bookmark" class="title">关于hibernate的多对多，有看法，请大家来看看解决下我的疑问。</a>
					<div>
						问题描述 是这样的,鄙人对hibernate用的不是很多关于hibernate多对多的时候我们平时都是用set集合来但是为什么不为hibernate像数据库那样,建立一个中间bean,来关联两边呢?像 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgwx4EM.html" rel="bookmark" class="title">井贤栋年会现场演讲：我们不只是globalization&comma; 更是g-localization</a>
					<div>
						阿里巴巴集团合伙人.蚂蚁金服集团CEO井贤栋在年会演讲中表示,蚂蚁生于阿里,长于阿里,系于阿里,每一位蚂蚁的同学带着阿里赋予的梦想,让科技成为向前发展的核心动力,从中国走向全球,服务全球的消费者和小微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEnqZz.html" rel="bookmark" class="title">bid后缀商机&colon;Welmory有限公司收购8&period;bid 用于大型竞拍网站</a>
					<div>
						bid域名含意:出价,投标:必得,志在必得 什么是.bid域名 关于.bid域名,是新顶级域名后缀,本身具有&quot;在线拍卖.竞标&quot;的意思.适合商品的竞拍,特别是现在电子商务的发展,很多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxE16Rp.html" rel="bookmark" class="title">请问大家在web工程中是如何控制路径？</a>
					<div>
						问题描述 大家在做项目时是使用的绝对路径还是相对路径?不同模块的跳转之前是如何控制的?我这边一没弄好从一个模块跳过去.比如直接进一级下面正常.从二级下面跳到一级CSS就全部丢失.布局乱套了.这种情况如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdm4g1z.html" rel="bookmark" class="title">lombok注解为何在eclipse不能编译成功？</a>
					<div>
						问题描述 导入的eclipse中maven项目,项目中已经加入lombok.jar包,但是不能编译成功什么原因求大神指点 解决方案 解决方案二:http://projectlombok.org/看上述 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQW6AWp.html" rel="bookmark" class="title">维基解密公布美外交密件第九日媒体看点</a>
					<div>
						北京时间12月8日消息,英国&lt;卫报&gt;等世界媒体北京时间12月7日继续发布维基解密披露的美国机密外交电报,以下是此次解密以来第九天各媒体主要看点,以下均已发布媒体当地时间为准. 第九天,12 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4ej0b.html" rel="bookmark" class="title">ICE之C&sol;S通信原理</a>
					<div>
						1 /* 2 在ICE文档中只需要声明module名称,接口名称,方法名称 3 */ 4 5 #ifndef SIMPLE_ICE 6 #define SIMPLE_ICE 7 8 module De ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
